#include "MK40N512MD100.h"




void DC_Low()   { PTE->PDOR &= ~(1 << 10); }
void DC_High()  { PTE->PDOR |= (1 << 10); }





// Inicjalizacja SPI0 i jego linii I/O (PTA14 - CS0, PTA15 - SCK, PTA16 - DOUT, PTA17 - DIN)
void SPI0Init()
{
	SIM->SCGC5 |= (1 << SIM_SCGC5_PORTA_SHIFT);
	SIM->SCGC6 |= (1 << SIM_SCGC6_DSPI0_SHIFT);

	PORTA->PCR[14] = PORT_PCR_MUX(2);
	PORTA->PCR[15] = PORT_PCR_MUX(2);
	PORTA->PCR[16] = PORT_PCR_MUX(2);
	PORTA->PCR[17] = PORT_PCR_MUX(2);

   	SPI0->MCR = (1 << SPI_MCR_DIS_TXF_SHIFT) | (1 << SPI_MCR_DIS_RXF_SHIFT) | (1 << SPI_MCR_MSTR_SHIFT) | SPI_MCR_PCSIS(1);
	SPI0->CTAR[0] = SPI_CTAR_FMSZ(7) | (1 << SPI_CTAR_CPOL_SHIFT) | (1 << SPI_CTAR_CPHA_SHIFT) | SPI_CTAR_PDT(3) 
	                | SPI_CTAR_PBR(0) | SPI_CTAR_BR(0);

}


void SPI0Write(char b, char h)
{
	if (h)
		SPI0->PUSHR = b | SPI_PUSHR_CTAS(0) | SPI_PUSHR_PCS(1);	
	  else
		SPI0->PUSHR = b | SPI_PUSHR_CTAS(0) | SPI_PUSHR_PCS(1) | (1 << SPI_PUSHR_CONT_SHIFT);	
		
    while (! (SPI0->SR & SPI_SR_RFDF_MASK));
    SPI0->POPR;
    SPI0->SR |= SPI_SR_RFDF_MASK;
}



void ISC15ANP4_Init(void)
{
	int i;
	char buffer[6];

	SPI0Init();
	
	//PTE10=D/C, PTE9=btnIn
	SIM->SCGC5 |= (1 << SIM_SCGC5_PORTE_SHIFT);|

	PORTE->PCR[10] = PORT_PCR_MUX(1);
	PORTE->PCR[9] = PORT_PCR_MUX(1) | (1 << PORT_PCR_PE_SHIFT) | PORT_PCR_IRQC(9);
	PTE->PDDR |= (1 << 10);
	PTE->PDDR &= ~(1 << 9);
	NVIC->ISER[2] |= (1 << 27);

	DC_High();
	for (i=0; i<0xfff;i++);
	DC_Low();

	SPI0Write(0x81, 0); SPI0Write(0x19, 1); // Contras for color A		
	SPI0Write(0x82, 0); SPI0Write(0x14, 1);	// Contras for color B
	SPI0Write(0x83, 0); SPI0Write(0x24, 1);	// Contras for color C
	SPI0Write(0x87, 0); SPI0Write(0x0F, 1);	// Master current control
	SPI0Write(0xA0, 0); SPI0Write(0x70, 1);	// Remap & color depth setting
	SPI0Write(0xA1, 0); SPI0Write(0x00, 1);	// Set display start line
	SPI0Write(0xA2, 0); SPI0Write(0x10, 1);	// Set display offset
	SPI0Write(0xA4, 1); 					// Normal display
	SPI0Write(0xA8, 0); SPI0Write(0x2F, 1);	// Multiplex ratio
	SPI0Write(0xAB, 0); SPI0Write(0x00, 0); SPI0Write(0x12, 0); SPI0Write(0x0C, 0); SPI0Write(0x14, 0); SPI0Write(0x12, 1); //Dim mode setting for color A, B &C
	SPI0Write(0xAD, 0); SPI0Write(0x8E, 1);	// Master configuration
	SPI0Write(0xB0, 0); SPI0Write(0x0B, 1);	// Power save mode
	SPI0Write(0xB1, 0); SPI0Write(0x44, 1);	// Phase 1 and 2 period adjustment
	SPI0Write(0xB3, 0); SPI0Write(0xA0, 1);	// Display clock divider/ oscillator frequency
	SPI0Write(0xB9, 1);						// Enable linear gray scale
	SPI0Write(0xBB, 0); SPI0Write(0x12, 1);	// Pre charge level
	SPI0Write(0xBE, 0); SPI0Write(0x28, 1);	// Set Vcomh
	SPI0Write(0xAF, 1); 					// Display on in normal mode	

	DC_High();
}

void ISC15ANP4_SetRangeToFullScreen()
{
	DC_Low();

	SPI0Write(0x15, 0); SPI0Write(0x10, 0); SPI0Write(0x4F, 1);	// Set column range
	
	SPI0Write(0x75, 0); SPI0Write(0x0, 0); SPI0Write(0x2F, 1);	// Set row range

	DC_High();		
}

void ISC15ANP4_DrawScreen(char * b)
{
	int i;
	DC_High();
	for (i = 0; i < 64*48*2; i++)
	{
		SPI0Write(b[i], 1);
	}
}
	 
void ISC15ANP4_Transition(char * from, char * to)
{
	int x, y, step = 0;
	DC_High();
	for (step = 0; step < 64; step+=5)
	{
		for (y = 0; y < 48; y++)
		{
			for (x = 0; x <= step; x++)
			{
				SPI0Write(to[2*(y * 64 + (63-step+x))], 1);				
				SPI0Write(to[2*(y * 64 + (63-step+x))+1], 1);		
			}
			for (x = step + 1; x < 64; x++)
			{
				SPI0Write(from[2*(y*64 + x -step)], 1);
				SPI0Write(from[2*(y*64 + x -step)+1], 1);		
			}
		}
	}
	ISC15ANP4_DrawScreen(to);
}
